
/******************************************************************************
* MODULE     : associate.gen.cc
* DESCRIPTION: Test program
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <associator.gen.h>
#include <file.gen.h>

#module code_associate
#import associator
#import file

int
main (int argc, char** argv) {
  char in[1000];
  string s;

  if ((argc==2) && (string (argv[1]) == "-h")) {
    cout << "\nassociate command line options:\n";
    cout << "    none          : usual associater\n";
    cout << "    -h            : this help message\n";
    cout << "    <lan1> <lan2> : translate from language 1 to language 2\n\n";
    exit (1);
  }

  while (TRUE) {
    int i;
    cout << "in ] ";
    for (i=0; i<999; i++) {
      cin.get(in[i]);
      if (in[i]=='\n') break;
    }
    in[i]='\0';
    string IN= in;
    if ((N(IN)>5) && (IN(0,5)=="load ")) {
      string name (&in[5]);
      cout << "out] Loading " << name << "\n";
      std_associator->load (name);
      continue;
    }
    else s= string (in);
    if (s == "quit") break;

    if (argc == 3) {
      string r= std_associator->translate (s, argv[1], argv[2]);
      cout << "out] " << r << "\n";
    }

    else {
      concepts cons= std_associator->execute (s);
      if (atom (cons)) {
	string r= std_associator->meaning (cons->item);
	if (N(r)>0) cout << "out] " << r << "\n";
      }
      if ((!nil (cons)) && (!atom (cons))) {
	int i=1;
	while (!nil (cons)) {
	  cout << i << "  ] " << std_associator->meaning (cons->item) << "\n";
	  i++;
	  cons= cons->next;
	}
      }
    }
  }

  return 0;
}

#endmodule // associate
