
/******************************************************************************
* MODULE     : fp_real.gen.h
* DESCRIPTION: fp_reals based on gmp
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <tree.gen.h>

#module fp_real
#import tree
#include <gmp.h>

struct fp_real_rep: public concrete_struct {
  mpf_t F;
  inline fp_real_rep () { mpf_init (F); }
  inline ~fp_real_rep () { mpf_clear (F); }
};

class fp_real {
#import concrete (fp_real, fp_real_rep)
public:
  fp_real ();
  fp_real (int i);
  fp_real (string s, int base= 10);
  operator string ();
  operator tree ();
};
#import code_concrete (fp_real, fp_real_rep)

void     set_fp_real_precision (int bits);
ostream& operator << (ostream& out, fp_real x);
fp_real  operator + (fp_real x, fp_real y);
fp_real  operator - (fp_real x);
fp_real  operator - (fp_real x, fp_real y);
fp_real  operator * (fp_real x, fp_real y);
fp_real  operator / (fp_real x, fp_real y);

inline void operator += (fp_real& x, fp_real y) { x=x+y; }
inline void operator -= (fp_real& x, fp_real y) { x=x-y; }
inline void operator *= (fp_real& x, fp_real y) { x=x*y; }
inline void operator /= (fp_real& x, fp_real y) { x=x/y; }

int  sign        (fp_real x);
bool operator == (fp_real x, fp_real y);
bool operator != (fp_real x, fp_real y);
bool operator <= (fp_real x, fp_real y);
bool operator >= (fp_real x, fp_real y);
bool operator <  (fp_real x, fp_real y);
bool operator >  (fp_real x, fp_real y);

#endmodule // fp_real
